class FMainClass extends AIInfo
{
	function GetAuthor()		{ return "SamuXarick"; }
	function GetName()			{ return "Road Pathfinder test"; }
	function GetDescription() 	{ return "Tests different Heaps"; }
	function GetVersion()		{ return 1; }
	function GetDate()			{ return "05-04-2020"; }
	function CreateInstance()	{ return "MainClass"; }
	function GetShortName()		{ return "RPFT"; }
	function GetAPIVersion()	{ return "1.10"; }
	
	function GetSettings() {
		AddSetting({
			name = "select_heap",
			description = "Select Priority Queue",
			easy_value = 0,
			medium_value = 0,
			hard_value = 0,
			custom_value = 0,
			flags = CONFIG_INGAME,
			min_value = 0,
			max_value = 3
		});

		AddLabels("select_heap", {
			_0 = "pathfinder.road 4 / graph.aystar 6 / queue.binary_heap 1",
			_1 = "pathfinder.road 4 / graph.aystar 6 / queue.fibonacci_heap 3",
			_2 = "pathfinder.road 4 / graph.aystar 6 / queue.native_heap 1",
			_3 = "pathfinder.road 4 / graph.aystar 6 / queue.priority_queue 2",
		});
		
		AddSetting({
			name = "build_signs",
			description = "Build Signs (skews total result)",
			easy_value = 0,
			medium_value = 0,
			hard_value = 0,
			custom_value = 0,
			flags = CONFIG_BOOLEAN | CONFIG_INGAME,
		});
		
		AddSetting({
			name = "build_roads",
			description = "Build Roads (skews multiple instances and total result, requires money)",
			easy_value = 0,
			medium_value = 0,
			hard_value = 0,
			custom_value = 0,
			flags = CONFIG_BOOLEAN | CONFIG_INGAME,
		});
	}
}

RegisterAI(FMainClass());
